from enum import IntEnum, Enum, auto


class SDDLFlags(Enum):
    SDDL_AUTO_INHERIT_REQ = auto()
    SDDL_AUTO_INHERITED = auto()
    PROTECTED = auto()
    NO_ACCESS_CONTROL = auto()


class AceFlags(IntEnum):
    OBJECT_INHERIT = 0x01
    CONTAINER_INHERIT = 0x02
    NO_PROPAGATE = 0x04
    INHERIT_ONLY = 0x08
    INHERITED = 0x10
    AUDIT_SUCCESS = 0x40
    TRUST_PROTECTED_FILTER = 0x40
    AUDIT_FAILURE = 0x80
    # CRITICAL_ACE_FLAG - Can't find this value


class AceType(IntEnum):
    ACCESS_ALLOWED = 0x0
    ACCESS_DENIED = 0x1
    SYSTEM_AUDIT = 0x2
    SYSTEM_ALARM = 0x3
    ACCESS_ALLOWED_COMPOUND = 0x4
    ACCESS_ALLOWED_OBJECT = 0x5
    ACCESS_DENIED_OBJECT = 0x6
    SYSTEM_AUDIT_OBJECT = 0x7
    SYSTEM_ALARM_OBJECT = 0x8
    ACCESS_ALLOWED_CALLBACK = 0x9
    ACCESS_DENIED_CALLBACK = 0xA
    ACCESS_ALLOWED_CALLBACK_OBJECT = 0xB
    ACCESS_DENIED_CALLBACK_OBJECT = 0xC
    SYSTEM_AUDIT_CALLBACK = 0xD
    SYSTEM_ALARM_CALLBACK = 0xE
    SYSTEM_AUDIT_CALLBACK_OBJECT = 0xF
    SYSTEM_ALARM_CALLBACK_OBJECT = 0x10
    SYSTEM_MANDATORY_LABEL = 0x11
    SYSTEM_RESOURCE_ATTRIBUTE = 0x12
    SYSTEM_SCOPED_POLICY_ID = 0x13
    SYSTEM_PROCESS_TRUST_LABEL = 0x14
    SYSTEM_ACCESS_FILTER = 0x15
